// *****************************************************************
// *                                                               *
// *       Copyright (c) Fast Corporation, 2019                    *
// *                                                               *
// *   All Rights Reserved.  Unpublished rights  reserved  under   *
// *   the copyright laws of the Japan.                            *
// *                                                               *
// *   The software contained on this media  is  proprietary  to   *
// *   and  embodies  the  confidential  technology  of  Fast      *
// *   Corporation.  Possession, use,  duplication  or             *
// *   dissemination of the software and media is authorized only  *
// *   pursuant to a valid written license from Fast Corporation.  *
// *                                                               *
// *****************************************************************

// LineHoughDlg.cpp : t@C
//

#include "stdafx.h"
#include "LineHough.h"
#include "LineHoughDlg.h"
#include "afxdialogex.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// AvP[Ṽo[WɎg CAboutDlg _CAO

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// _CAO f[^
#ifdef AFX_DESIGN_TIME
	enum { IDD = IDD_ABOUTBOX };
#endif

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

// 
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(IDD_ABOUTBOX)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CLineHoughDlg _CAO



CLineHoughDlg::CLineHoughDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(IDD_LINEHOUGH_DIALOG, pParent)
	, m_strGrabTime(_T(""))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);


	DWORD     bkColor = GetSysColor(COLOR_3DFACE);
	m_brGr.CreateSolidBrush(bkColor);
}

void CLineHoughDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_STATIC_DISPLAYZONE, m_displayzone);
	DDX_Control(pDX, IDC_TAB, m_tab);
	DDX_Control(pDX, IDC_CHECK_EDGE_DISPLAY, m_disp_edge);
	DDX_Control(pDX, IDC_LIST_RESULT, m_list_result);
	DDX_Text(pDX, IDC_EDIT_TIME, m_strGrabTime);
}

BEGIN_MESSAGE_MAP(CLineHoughDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_LOAD_IMG_FILE, &CLineHoughDlg::OnBnClickedButtonLoadImgFile)
	ON_BN_CLICKED(IDC_BUTTON_DETECTION, &CLineHoughDlg::OnBnClickedButtonDetection)
	ON_BN_CLICKED(IDC_CHECK_EDGE_DISPLAY, &CLineHoughDlg::OnBnClickedCheckEdgeDisplay)
	ON_BN_CLICKED(IDC_CHECK_SET_AREA, &CLineHoughDlg::OnBnClickedCheckSetArea)
	ON_BN_CLICKED(IDC_CHECK_ASCOPE, &CLineHoughDlg::OnBnClickedCheckAscope)
	ON_NOTIFY(TCN_SELCHANGE, IDC_TAB, &CLineHoughDlg::OnTcnSelchangeTab)
	ON_BN_CLICKED(IDC_BUTTON_MAG1, &CLineHoughDlg::OnBnClickedButtonMag1)
	ON_BN_CLICKED(IDC_BUTTON_FIT, &CLineHoughDlg::OnBnClickedButtonFit)
	ON_BN_CLICKED(IDC_BUTTON_PLUS, &CLineHoughDlg::OnBnClickedButtonPlus)
	ON_BN_CLICKED(IDC_BUTTON_MINUS, &CLineHoughDlg::OnBnClickedButtonMinus)
	ON_BN_CLICKED(IDC_BUTTON_SAVE_IMAGE, &CLineHoughDlg::OnBnClickedButtonSaveImage)
	ON_WM_DRAWITEM()
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LIST_RESULT, &CLineHoughDlg::OnLvnItemchangedListResult)
END_MESSAGE_MAP()


// CLineHoughDlg bZ[W nh[

BOOL CLineHoughDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// "o[W..." j[VXe j[ɒǉ܂B

	// IDM_ABOUTBOX ́AVXe R}h͈͓̔ɂȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAÕACRݒ肵܂BAvP[ṼC EBhE_CAOłȂꍇA
	//  Framework ́A̐ݒIɍs܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACR̐ݒ
	SetIcon(m_hIcon, FALSE);		// ACR̐ݒ

	// TODO: ɒǉ܂B

	FVCL::InitVisionLibrary(); // WIL 
	FVCL::EVCbasic::DLLChainResource(NULL); //
	fnSetView();


	m_tab.InsertItem(0, L"Hough");
	m_tab.InsertItem(1, L"Edge");	

	tab_hough.Create(IDD_DIALOG_HOUGH_PARAM, &m_tab);
	tab_edge.Create(IDD_DIALOG_EDGE_PARAM, &m_tab);

	// ^ȗ傫
	CRect tab_rect;
	CRect rect;
	m_tab.GetItemRect(0, &tab_rect);

	// ^u̍
	int tab_height = tab_rect.bottom * m_tab.GetRowCount();
	
	tab_hough.GetClientRect(&rect);
	rect.OffsetRect(5, 5 + tab_height);
	tab_hough.ShowWindow(SW_SHOW);
	tab_hough.SetWindowPos(NULL, 5, 5 + tab_height, 0, 0, SWP_NOZORDER | SWP_NOSIZE);
	
	tab_edge.GetClientRect(&rect);
	rect.OffsetRect(5, 5 + tab_height);
	tab_edge.ShowWindow(SW_HIDE);
	tab_edge.SetWindowPos(NULL, 5, 5 + tab_height, 0, 0, SWP_NOZORDER | SWP_NOSIZE);


	//p[^̏
	m_correlationparam = m_houghcorrelation.GetParamEdge();
	m_sobelparam = m_houghsobel.GetParamEdge();	
	fnLineHoughPraramIni();

	m_list_result.InsertColumn(0, _T("No"), LVCFMT_LEFT, 90);
	m_list_result.InsertColumn(1, _T("X"), LVCFMT_LEFT, 90);
	m_list_result.InsertColumn(2, _T("Y"), LVCFMT_LEFT, 90);
	m_list_result.InsertColumn(3, _T("Radius"), LVCFMT_LEFT, 90);
	m_list_result.InsertColumn(4, _T("Score"), LVCFMT_LEFT, 90);

	m_list_result.SetExtendedStyle(LVS_EX_FULLROWSELECT);
	return TRUE;  // tH[JXRg[ɐݒ肵ꍇATRUE Ԃ܂B
}

void CLineHoughDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// _CAOɍŏ{^ǉꍇAACR`悷邽߂
//  ̃R[hKvłBhLg/r[ fg MFC AvP[V̏ꍇA
//  ́AFramework ɂĎIɐݒ肳܂B

void CLineHoughDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// NCAg̎lp`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR̕`
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// [U[ŏEBhEhbOĂƂɕ\J[\擾邽߂ɁA
//  VXe̊֐Ăяo܂B
HCURSOR CLineHoughDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

// set evc view
void CLineHoughDlg::fnSetView()
{
	// EVC View
	CRect rect;
	m_displayzone.GetWindowRect(&rect);
	ScreenToClient((LPRECT)&rect);

	try
	{
		m_objView.Create(IDC_STATIC_DISPLAYZONE, rect, this);
		m_objView.SetImage(&m_src);
		FVCL::GDI::CFvGdiBrush	brush;
		brush.SetColor(RGB(0x100, 0x100, 0x100));
		brush.SetStyle(FVCL::GDI::BrushStyle::Solid);
		m_objView.m_display.SetBackground(brush);
		m_objView.SetFocusOption(FVCL::FocusOption::LDOWN);


		// I[oC𐶐āA|C^ۊǂ܂.
		m_OverlayEdge = m_objView.m_display.CreateOverlay();
		m_OverlayArea = m_objView.m_display.CreateOverlay();

		m_OverlayEdge->SetEnable(true);    // =.
		m_OverlayEdge->SetScaling(true);   // Lk.
		m_OverlayEdge->SetScalingMode(FVCL::GDI::ScalingMode::Center);

		m_OverlayArea->SetEnable(true);    // =.
		m_OverlayArea->SetScaling(true);   // Lk.
		m_OverlayArea->SetScalingMode(FVCL::GDI::ScalingMode::Center);


	}

	catch (...)
	{
		AfxMessageBox(_T("exception occured."), MB_OK | MB_ICONEXCLAMATION);
	}

}



//摜[h
void CLineHoughDlg::OnBnClickedButtonLoadImgFile()
{
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B
	try
	{
		TCHAR	strFilePath[255];
		::GetModuleFileName(AfxGetInstanceHandle(), strFilePath, 255);

		TCHAR szFilters[] = _T("bmp file(*.bmp)|*.bmp||");
		CFileDialog cFileDlg(TRUE, _T("bmp"), NULL, OFN_FILEMUSTEXIST | OFN_HIDEREADONLY, szFilters, this);
		cFileDlg.m_ofn.lpstrInitialDir = strFilePath;



		if (IDOK == cFileDlg.DoModal())
		{
			CString strPath = cFileDlg.GetPathName();
			FVCL::File::CFvImageFileBmp objFile;
			objFile.Load(strPath.GetBuffer(strPath.GetLength()), &m_src);

			FVCL::Data::CFvRectangle rect = m_src.GetWindow();
			m_dst.SetSize(m_src.GetHorzSize(), m_src.GetVertSize(), FVCL::ImageType::UC8, 1, 0);

		}

		m_objView.SetImage(&m_src);		//\摜̐ݒ
		m_objView.FitImageSize();		//r[TCY̍œK
		m_objView.ReDraw();				//\XV

	}
	catch (const FVCL::CFveException& e)
	{
		INT	code = e.GetExceptionCode();
		INT	err = e.GetErrorCode();
		CString str;
		str.Format(_T("(%d): LoadImg Error"), e.GetErrorCode());
		AfxMessageBox(str, MB_OK | MB_ICONEXCLAMATION);
	}
	catch (...)
	{
		AfxMessageBox(_T("exception occured."), MB_OK | MB_ICONEXCLAMATION);
	}
}

//ntos
void CLineHoughDlg::OnBnClickedButtonDetection()
{
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B
	//`NA
	m_OverlayArea->ClearFigures();
	m_list_result.DeleteAllItems();

	//Ώۉ摜̗L
	if (FVCL_ErrorCode::_SUCCESS != FVCL::Hough::CFvLineHoughCorrelationEdge::CheckValidity(m_src))
		return;

	//p[^ݒ
	if (fnLineHoughPraramSet())
	{
		//ntos
		if (fnLineHoughExec())
		{
			//ʕ\
			fnResultDisplay();
		}		
	}	

}

//GbW\
void CLineHoughDlg::OnBnClickedCheckEdgeDisplay()
{
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B
	if (m_disp_edge.GetCheck())
	{
		try
		{
			FVCL::CFvArray<FVCL::Edge::CFvEdgeData> edges;

			//`NA
			m_OverlayEdge->ClearFigures();

			//p[^ݒ
			if (fnLineHoughPraramSet())
			{


				if (tab_hough.m_select_filter.GetCurSel() == 0)
				{
					//փGbWp[^ݒ

					m_houghcorrelation.SetSrcImage(0, &m_src);
					m_houghcorrelation.Execute();
					m_houghcorrelation.GetEdges(&edges);
				}
				else
				{
					//\[xGbWp[^ݒ
					m_houghsobel.SetSrcImage(0, &m_src);
					m_houghsobel.Execute();
					m_houghsobel.GetEdges(&edges);

				}

				//edges_ݒ

				FVCL::GDI::CFvGdiPoints gdi_pos(edges);
				gdi_pos.SetStyle(FVCL::GDI::FigureStyle::Xmark);
				gdi_pos.GetPen().SetColor(RGB(0xFF, 0xFF, 0x00));
				m_OverlayEdge->DrawFigure(gdi_pos);
				m_objView.ReDraw();				//\XV
			}
		}

		catch (const FVCL::CFveException& e)
		{
			INT	code = e.GetExceptionCode();
			INT	err = e.GetErrorCode();
			CString str;
			str.Format(_T("(%d): Reduction Error"), e.GetErrorCode());
			AfxMessageBox(str, MB_OK | MB_ICONEXCLAMATION);
		}
		catch (...)
		{
			AfxMessageBox(_T("exception occured."), MB_OK | MB_ICONEXCLAMATION);
		}
	}
	else
	{
		//`NA
		m_OverlayEdge->ClearFigures();
	}
	m_objView.ReDraw();				//\XV

}

//p[^ݒ
bool CLineHoughDlg::fnLineHoughPraramSet()
{
	if (tab_hough.m_select_filter.GetCurSel() == 0)
	{
		//փGbWp[^ݒ
		m_param = m_houghcorrelation.GetParam();
	}
	else
	{
		//\[xGbWp[^ݒ
		m_param = m_houghsobel.GetParam();
	}

	//v{
	m_param.SetRequestNum((int)tab_hough.m_spin_request_num.GetPos());

	//px͈
	CString str;
	tab_hough.GetDlgItemText(IDC_EDIT_ANGLE_ST, str);
	double temp1 = ::_ttof(str);

	tab_hough.GetDlgItemText(IDC_EDIT_ANGLE_ED, str);
	double temp2 = ::_ttof(str);

	if ((temp1 <= temp2) && ((temp2 - temp1) < 360))
	{
		m_param.SetAngleSt(FVCL::Data::CFvAngle(temp1));
		m_param.SetAngleEd(FVCL::Data::CFvAngle(temp2));
	}
	else
	{
		AfxMessageBox(_T("px͈͂̏𖞂Ă܂"), MB_OK | MB_ICONEXCLAMATION);
		return false;
	}

	//px͈͂̕Е
	m_param.SetVoteWidth(tab_hough.GetDlgItemInt(IDC_EDIT_VOTE_WIDTH, NULL, false));
	//ϕɑlTCY
	m_param.SetRegionR(tab_hough.GetDlgItemInt(IDC_EDIT_REGION_R, NULL, false));
	//ƕɑlTCY̐ݒ 
	m_param.SetRegionQ(tab_hough.GetDlgItemInt(IDC_EDIT_REGION_Q, NULL, false));

	//p[^ݒ
	if (tab_hough.m_select_filter.GetCurSel() == 0)
	{
		m_correlationparam = m_houghcorrelation.GetParamEdge();

		int temp3 = (int)(tab_edge.m_spin_region_width.GetPos());
		int temp4 = (int)(tab_edge.m_spin_region_height.GetPos());

		if ((temp4 <= temp3) && ( (temp3 * temp4) <= 255))
		{
			m_correlationparam.SetRegionWidth(temp3);
			m_correlationparam.SetRegionHeight(temp4);
		}
		else
		{
			AfxMessageBox(_T("Ǐ̈TCY̏𖞂Ă܂"), MB_OK | MB_ICONEXCLAMATION);
			return false;
		}

		//VOCh
		tab_edge.GetDlgItemText(IDC_EDIT_SIGMOIDK, str);
		m_correlationparam.SetSigmoidK(::_ttof(str));
		
		//U臒l
		tab_edge.GetDlgItemText(IDC_EDIT_VER_THRESH, str);
		m_correlationparam.SetVarThreshold(::_ttof(str));

		//GbWx臒l
		m_correlationparam.SetEdgeThreshold((int)tab_edge.m_spin_edge_thresh.GetPos());
		m_correlationparam.SetNmsLength((int)tab_edge.m_nms_length.GetPos());


		if (tab_hough.m_border.GetCheck())
		{
			//[[h
			m_houghcorrelation.SetBorderMode(FVCL::BorderMode::Continuous);
		}
		else
		{
			//{[_[gȂ
			m_houghcorrelation.SetBorderMode(FVCL::BorderMode::None);
		}

		m_houghcorrelation.SetParamEdge(m_correlationparam);
		m_houghcorrelation.SetParam(m_param);
	}
	else
	{
		//\[xGbWp[^ݒ
		m_sobelparam = m_houghsobel.GetParamEdge();

		m_sobelparam.SetEdgeThreshold((int)tab_edge.m_spin_edge_thresh.GetPos());
		m_sobelparam.SetNmsLength((int)tab_edge.m_nms_length.GetPos());

		if (tab_hough.m_border.GetCheck())
		{
			//[[h
			m_houghsobel.SetBorderMode(FVCL::BorderMode::Continuous);
		}
		else
		{
			//{[_[gȂ
			m_houghsobel.SetBorderMode(FVCL::BorderMode::None);
		}

		m_houghsobel.SetParamEdge(m_sobelparam);
		m_houghsobel.SetParam(m_param);

	}

	return true;
	
}

//p[^_CAOݒ
void CLineHoughDlg::fnLineHoughPraramIni()
{
	CString str;
	FVCL::Data::CFvAngle angle;

	//p[^ݒ
	if (tab_hough.m_select_filter.GetCurSel() == 0)
	{
		//փGbWp[^ݒ
		m_param = m_houghcorrelation.GetParam();
	}
	else
	{
		//\[xGbWp[^ݒ
		m_param = m_houghsobel.GetParam();
	}

	//v{
	tab_hough.m_spin_request_num.SetPos(m_param.GetRequestNum());


	//px͈(n_)
	angle = m_param.GetAngleSt();
	str.Format(_T("%.2lf"), angle.GetDegree());
	tab_hough.SetDlgItemText(IDC_EDIT_ANGLE_ST, str);

	//px͈(I_)
	angle = m_param.GetAngleEd();
	str.Format(_T("%.2lf"), angle.GetDegree());
	tab_hough.SetDlgItemText(IDC_EDIT_ANGLE_ED, str);

	//
	tab_hough.SetDlgItemInt(IDC_EDIT_VOTE_WIDTH, m_param.GetVoteWidth(), false);
	//ϕɑlTCY
	tab_hough.SetDlgItemInt(IDC_EDIT_REGION_R, m_param.GetRegionR(), false);
	//ƕɑlTCY̐ݒ 
	tab_hough.SetDlgItemInt(IDC_EDIT_REGION_Q, m_param.GetRegionQ(), false);
	
	//EdgeotB^p[^ݒ
	if (tab_hough.m_select_filter.GetCurSel() == 0)
	{
		tab_edge.m_spin_region_width.SetRange(3, 255);
		tab_edge.m_spin_region_height.SetRange(1, 15);
		tab_edge.m_spin_edge_thresh.SetRange(0, 255);
		tab_edge.m_nms_length.SetRange(1, 1000);

		// փGbWtB^pp[^\
		tab_edge.GetDlgItem(IDC_EDIT_REGION_WIDTH)->ShowWindow(SW_SHOW);
		tab_edge.GetDlgItem(IDC_EDIT_REGION_HEIGHT)->ShowWindow(SW_SHOW);
		tab_edge.GetDlgItem(IDC_SPIN_REGION_WIDTH)->ShowWindow(SW_SHOW);
		tab_edge.GetDlgItem(IDC_SPIN_REGION_HEIGHT)->ShowWindow(SW_SHOW);
		tab_edge.GetDlgItem(IDC_EDIT_SIGMOIDK)->ShowWindow(SW_SHOW);
		tab_edge.GetDlgItem(IDC_EDIT_VER_THRESH)->ShowWindow(SW_SHOW);
		tab_edge.GetDlgItem(IDC_STATIC3)->ShowWindow(SW_SHOW);
		tab_edge.GetDlgItem(IDC_STATIC4)->ShowWindow(SW_SHOW);
		tab_edge.GetDlgItem(IDC_STATIC5)->ShowWindow(SW_SHOW);
		tab_edge.GetDlgItem(IDC_STATIC6)->ShowWindow(SW_SHOW);
		tab_edge.GetDlgItem(IDC_STATIC7)->ShowWindow(SW_SHOW);
		tab_edge.GetDlgItem(IDC_STATIC8)->ShowWindow(SW_SHOW);

		//Ǐ̈TCY
		tab_edge.m_spin_region_width.SetPos(m_correlationparam.GetRegionWidth());
		tab_edge.m_spin_region_height.SetPos(m_correlationparam.GetRegionHeight());

		//VOCh֐
		str.Format(_T("%.2lf"), m_correlationparam.GetSigmoidK());
		tab_edge.SetDlgItemText(IDC_EDIT_SIGMOIDK, str);

		//U臒l
		str.Format(_T("%.2lf"), m_correlationparam.GetVarThreshold());
		tab_edge.SetDlgItemText(IDC_EDIT_VER_THRESH, str);

		//GbWxl
		tab_edge.m_spin_edge_thresh.SetPos(m_correlationparam.GetEdgeThreshold());

		//ɑ}̃tB^Е		
		tab_edge.m_nms_length.SetPos(m_correlationparam.GetNmsLength());

	}
	else
	{
		tab_edge.m_spin_edge_thresh.SetRange(0, 1023);
		tab_edge.m_nms_length.SetRange(1, 1000);

		// փGbWtB^pp[^\
		tab_edge.GetDlgItem(IDC_EDIT_REGION_WIDTH)->ShowWindow(SW_HIDE);
		tab_edge.GetDlgItem(IDC_EDIT_REGION_HEIGHT)->ShowWindow(SW_HIDE);
		tab_edge.GetDlgItem(IDC_SPIN_REGION_WIDTH)->ShowWindow(SW_HIDE);
		tab_edge.GetDlgItem(IDC_SPIN_REGION_HEIGHT)->ShowWindow(SW_HIDE);
		tab_edge.GetDlgItem(IDC_EDIT_SIGMOIDK)->ShowWindow(SW_HIDE);
		tab_edge.GetDlgItem(IDC_EDIT_VER_THRESH)->ShowWindow(SW_HIDE);
		tab_edge.GetDlgItem(IDC_STATIC3)->ShowWindow(SW_HIDE);
		tab_edge.GetDlgItem(IDC_STATIC4)->ShowWindow(SW_HIDE);
		tab_edge.GetDlgItem(IDC_STATIC5)->ShowWindow(SW_HIDE);
		tab_edge.GetDlgItem(IDC_STATIC6)->ShowWindow(SW_HIDE);
		tab_edge.GetDlgItem(IDC_STATIC7)->ShowWindow(SW_HIDE);
		tab_edge.GetDlgItem(IDC_STATIC8)->ShowWindow(SW_HIDE);

		//GbWxl
		tab_edge.m_spin_edge_thresh.SetPos(m_sobelparam.GetEdgeThreshold());

		//ɑ}̃tB^Е		
		tab_edge.m_nms_length.SetPos(m_sobelparam.GetNmsLength());

	}
	
	if (tab_hough.m_select_filter.GetCurSel() == 0)
	{
		if (m_houghcorrelation.GetBorderMode())
		{
			//[[h
			tab_hough.m_border.SetCheck(true);
		}
		else
		{
			//{[_[gȂ
			tab_hough.m_border.SetCheck(false);
		}
	}
	else
	{
		if (m_houghsobel.GetBorderMode())
		{
			//[[h
			tab_hough.m_border.SetCheck(true);
		}
		else
		{
			//{[_[gȂ
			tab_hough.m_border.SetCheck(false);
		}		
	}
}


//͈͂̐ݒ
void CLineHoughDlg::OnBnClickedCheckSetArea()
{
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B
	int type = m_objView.GetCursorType();

	if (type == FVCL::CursorType::PROCAREA)
	{
		m_objView.SetCursorType(FVCL::CursorType::USERMODE);
	}
	else
	{	
		m_objView.SetCursorType(FVCL::CursorType::PROCAREA);
	}

	//\XV
	m_objView.ReDraw();				

}

//Ascope\
void CLineHoughDlg::OnBnClickedCheckAscope()
{
		// TODO: ɃRg[ʒmnh[ R[hǉ܂B
		int type = m_objView.GetCursorType();

		if (type == FVCL::CursorType::ASCOPE)
		{
			m_objView.SetCursorType(FVCL::CursorType::USERMODE);
		}
		else
		{
			m_objView.SetCursorType(FVCL::CursorType::ASCOPE);
		}

		//\XV
		m_objView.ReDraw();				

}


//Tab؂ւ
void CLineHoughDlg::OnTcnSelchangeTab(NMHDR *pNMHDR, LRESULT *pResult)
{
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B
	int nTabNo;
	nTabNo = m_tab.GetCurSel();

	if (nTabNo == 0)
	{
		tab_hough.ShowWindow(SW_SHOW);
		tab_edge.ShowWindow(SW_HIDE);

	}
	else if (nTabNo == 1)
	{
		tab_edge.ShowWindow(SW_SHOW);
		tab_hough.ShowWindow(SW_HIDE);
	}
	*pResult = 0;
}


void CLineHoughDlg::OnBnClickedButtonMag1()
{
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B
	//{ɔ{ݒ
	m_objView.m_display.SetMagnification(1.0);		
		
	//ĕ`
	m_objView.ReDraw();				//\XV
}


void CLineHoughDlg::OnBnClickedButtonFit()
{
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B
	m_objView.FitImageSize();		//r[TCY̍œK
	m_objView.ReDraw();				//\XV
}


void CLineHoughDlg::OnBnClickedButtonPlus()
{
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B
	double dVal = 0;
	dVal = m_objView.m_display.GetMagnification();
	dVal = dVal + 0.5;

	//{̐ݒ
	m_objView.m_display.SetMagnification(dVal);
	//ĕ`
	m_objView.ReDraw();
}


void CLineHoughDlg::OnBnClickedButtonMinus()
{
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B
	
	double dVal = 0;
	dVal = m_objView.m_display.GetMagnification();
	dVal = dVal - 0.5;

	//0ȉݒ肷ƃG[ɂȂ̂0.1ݒ肷
	if(dVal <= 0)
	{ 
		dVal = 0.1;
	}

	//{̐ݒ
	m_objView.m_display.SetMagnification(dVal);	
	//ĕ`
	m_objView.ReDraw();
}


void CLineHoughDlg::OnBnClickedButtonSaveImage()
{
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B
	//get program directory
	TCHAR	strFilePath[255];
	::GetModuleFileName(AfxGetInstanceHandle(), strFilePath, 255);

	TCHAR szFilters[] = _T("bmp file(*.bmp)|*.bmp||");
	CFileDialog cFileDlg(FALSE, _T("bmp"), NULL, OFN_FILEMUSTEXIST | OFN_HIDEREADONLY, szFilters, this);
	cFileDlg.m_ofn.lpstrInitialDir = strFilePath;

	if (IDOK == cFileDlg.DoModal())
	{
		CString strPath = cFileDlg.GetPathName();
		FVCL::File::CFvImageFileBmp objFile;
		objFile.Save(strPath.GetBuffer(strPath.GetLength()), *m_objView.GetImage());
	}

}

//s
bool CLineHoughDlg::fnLineHoughExec()
{
	bool result = true;
	CString str;

	try
	{
		if (tab_hough.m_select_filter.GetCurSel() == 0)
		{
			//փGbWp[^ݒ
			m_houghcorrelation.SetSrcImage(0, &m_src);
			m_houghcorrelation.SetResult(&m_result);

			m_objTimeCounter.Start();

			result = m_houghcorrelation.Execute();

			str.Format(_T("%.3f"), m_objTimeCounter.Stop());
			SetDlgItemText(IDC_EDIT_TIME, str);


			if (!result)
			{
				SetDlgItemText(IDC_EDIT_TIME, str);
				INT	err = m_houghcorrelation.GetErrorCode();
				str.Format(_T("(%d): Execute Error"), err);
				AfxMessageBox(str, MB_OK | MB_ICONEXCLAMATION);
			}
		}
		else
		{
			//\[xGbWp[^ݒ
			m_houghsobel.SetSrcImage(0, &m_src);
			m_houghsobel.SetResult(&m_result);

			m_objTimeCounter.Start();

			result = m_houghsobel.Execute();


			str.Format(_T("%.3f"), m_objTimeCounter.Stop());
			SetDlgItemText(IDC_EDIT_TIME, str);


			if (!result)
			{
				SetDlgItemText(IDC_EDIT_TIME, str);
				INT	err = m_houghsobel.GetErrorCode();
				str.Format(_T("(%d): Execute Error"), err);
				AfxMessageBox(str, MB_OK | MB_ICONEXCLAMATION);
			}
		}	
	}
	catch (const FVCL::CFveException& e)
	{
		INT	code = e.GetExceptionCode();
		INT	err = e.GetErrorCode();
		CString str;
		str.Format(_T("(%d): Execute Error"), e.GetErrorCode());
		AfxMessageBox(str, MB_OK | MB_ICONEXCLAMATION);
	}
	catch (...)
	{
		AfxMessageBox(_T("exception occured."), MB_OK | MB_ICONEXCLAMATION);
	}

	return result;
}

void CLineHoughDlg::fnResultDisplay()
{
	int count= m_result.GetCount();
	CString str;

	// `}`̐ƒǉ
	for (UINT i = 0; i < (m_result.GetCount()); i++)
	{
		FVCL::Hough::CFvLineHoughData data;
		m_result.GetData(i, &data);

		// f[^
		FVCL::GDI::CFvGdiLine line(data.a, data.b, data.c);
		line.GetPen().SetColor(RGB(255, 0, 0));

		// I[oC֒ǉ 
		m_OverlayArea->DrawFigure(line);

		str.Format(_T("%d"), i);
		int nIndex = m_list_result.InsertItem(i, str);

		str.Format(_T("%.2lf"), data.a);
		m_list_result.SetItemText(nIndex, 1, str);

		str.Format(_T("%.2lf"), data.b);
		m_list_result.SetItemText(nIndex, 2, str);

		str.Format(_T("%.2lf"), data.c);
		m_list_result.SetItemText(nIndex, 3, str);

		str.Format(_T("%d"), data.score);
		m_list_result.SetItemText(nIndex, 4, str);
	}

	//\XV
	m_objView.ReDraw();
}



LRESULT CLineHoughDlg::WindowProc(UINT message, WPARAM wParam, LPARAM lParam)
{
	// TODO: ɓȃR[hǉ邩A͊NXĂяoĂB
	
	if (message == MY_MESSAGE)
	{
		fnLineHoughPraramIni();
	}

	return CDialogEx::WindowProc(message, wParam, lParam);
}


void CLineHoughDlg::OnLvnItemchangedListResult(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B
	int iSelected = m_list_result.GetNextItem(-1, LVNI_SELECTED);
	int index = 0;


	//IXĝ݃I[o[C\AXgȊOIꍇSI[o[C\B
	for (int i = 0; i < m_list_result.GetItemCount(); i++)
	{
		bool bEnable;

		//XgI
		if (iSelected == i)
		{
			bEnable = true;
		}
		else
		{
			bEnable = false;        //XgȊOIꍇSTRUEݒ肷
		}

		//IACe\i\jɂ
		m_OverlayArea->GetFigure(index)->SetEnable(bEnable);
		index = index + 1;
	}

	//\XV
	m_objView.ReDraw();

	*pResult = 0;
}



